//
//
//
//
//
var script$2 = {
  name: "FileIconPicker",
  props: {
    fileName: {
      type: String,
      required: true
    }
  },

  data() {
    return {
      fileIcon: "bi bi-folder-fill",
      style: {
        color: "#fdb813"
      }
    };
  },

  created() {
    this.checkIcon();
  },

  methods: {
    checkIcon() {
      if ( // Word documents
      this.fileName.endsWith(".docx") || this.fileName.endsWith(".doc") || this.fileName.endsWith(".rtf") || this.fileName.endsWith(".odt")) {
        this.style = {
          color: "#1b7ced"
        };
        this.fileIcon = "bi bi-file-earmark-word-fill";
      } else if ( // Spreadsheets
      this.fileName.endsWith(".xlsx") || this.fileName.endsWith(".csv") || this.fileName.endsWith(".xls") || this.fileName.endsWith(".ods")) {
        this.style = {
          color: "#1d6f42"
        };
        this.fileIcon = "bi bi-file-earmark-spreadsheet-fill";
      } else if ( // Power point
      this.fileName.endsWith(".bmp") || this.fileName.endsWith(".ppsx") || this.fileName.endsWith(".pptx") || this.fileName.endsWith(".ppt")) {
        this.style = {
          color: "#d04423"
        };
        this.fileIcon = "bi bi-file-earmark-easel-fill";
      } else if ( // Images
      this.fileName.endsWith(".jpg") || this.fileName.endsWith(".img") || this.fileName.endsWith(".png") || this.fileName.endsWith(".svg") || this.fileName.endsWith(".gif") || this.fileName.endsWith(".tiff")) {
        this.style = {
          color: "#8C9C16"
        };
        this.fileIcon = "bi bi-file-image-fill";
      } else if ( // Programming
      this.fileName.endsWith(".vue") || this.fileName.endsWith(".ts") || this.fileName.endsWith(".html") || this.fileName.endsWith(".css") || this.fileName.endsWith(".sh") || this.fileName.endsWith(".c") || this.fileName.endsWith(".cs") || this.fileName.endsWith(".cpp")) {
        this.style = {
          color: "#15B59F"
        };
        this.fileIcon = "bi bi-file-earmark-binary-fill";
      } else if (this.fileName.endsWith(".js")) {
        // Javascript
        this.style = {
          color: "#fdb813"
        };
        this.fileIcon = "bi bi-file-earmark-code-fill";
      } else if (this.fileName.endsWith(".php")) {
        // PHP
        this.style = {
          color: "#474A8A"
        };
        this.fileIcon = "bi bi-file-earmark-code-fill";
      } else if (this.fileName.endsWith(".pdf")) {
        // Pdf
        this.style = {
          color: "#ff0000"
        };
        this.fileIcon = "bi bi-file-earmark-post";
      } else {
        this.style = {
          color: "#000"
        };
        this.fileIcon = "bi bi-file-earmark-fill";
      }
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

/* script */
const __vue_script__$2 = script$2;
/* template */

var __vue_render__$2 = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('i', {
    class: _vm.fileIcon,
    style: _vm.style
  });
};

var __vue_staticRenderFns__$2 = [];
/* style */

const __vue_inject_styles__$2 = undefined;
/* scoped */

const __vue_scope_id__$2 = undefined;
/* module identifier */

const __vue_module_identifier__$2 = undefined;
/* functional template */

const __vue_is_functional_template__$2 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

const __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$2,
  staticRenderFns: __vue_staticRenderFns__$2
}, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

var FileIconPicker = __vue_component__$2;

//
var script$1 = {
  name: "TreeListItem",
  components: {
    TreeListItem,
    FileIconPicker
  },
  props: {
    options: {
      type: Object,
      required: true
    },
    data: {
      required: true
    }
  },

  data() {
    return {
      isOpen: false,
      hoverTitle: false
    };
  },

  computed: {
    isLeaf() {
      return this.data[0]["isLeaf"];
    }

  },
  methods: {
    toggle() {
      if (!this.data[0]["isLeaf"]) {
        this.isOpen = !this.isOpen;
      }
    },

    trimText(text) {
      if (text.length > 20) {
        let length = text.length;
        let trimmed = text.substr(0, 11 - 1) + "..." + text.substr(length - 7, length - 1);
        return trimmed;
      } else {
        return text;
      }
    }

  }
};

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('li', [_c('div', {
    class: _vm.hoverTitle ? 'item-hover' : 'item',
    on: {
      "click": _vm.toggle,
      "mouseenter": function ($event) {
        _vm.hoverTitle = true;
      },
      "mouseleave": function ($event) {
        _vm.hoverTitle = false;
      }
    }
  }, [!_vm.isOpen && !_vm.isLeaf ? _c('i', {
    staticClass: "bi bi-icon-caret-right-fill"
  }) : _vm._e(), _vm._v(" "), _vm.isOpen && !_vm.isLeaf ? _c('i', {
    staticClass: "bi bi-icon-caret-down-fill"
  }) : _vm._e(), _vm._v(" "), !_vm.isLeaf && !_vm.isOpen ? _c('i', {
    staticClass: "bi bi-icon-folder-fill",
    staticStyle: {
      "color": "#f8d775"
    }
  }) : _vm._e(), _vm._v(" "), !_vm.isLeaf && _vm.isOpen ? _c('i', {
    staticClass: "bi bi-icon-folder2-open",
    staticStyle: {
      "color": "#f8d775"
    }
  }) : _vm._e(), _vm._v(" "), _vm.isLeaf ? _c('FileIconPicker', {
    attrs: {
      "fileName": _vm.data[0]['title']
    }
  }) : _vm._e(), _vm._v(" "), !_vm.isLeaf ? _c('span', {
    staticClass: "ml-1"
  }, [_vm._v(_vm._s(_vm.data[0]["title"]))]) : _vm._e(), _vm._v(" "), _vm.isLeaf ? _c('span', {
    staticClass: "ml-1"
  }, [_vm._v("\n      " + _vm._s(_vm.trimText(_vm.data[0]["title"])) + "\n    ")]) : _vm._e()], 1), _vm._v(" "), _c('ul', {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.isOpen,
      expression: "isOpen"
    }],
    staticStyle: {
      "list-style": "none"
    }
  }, _vm._l(_vm.data[0]['children'], function (child, index) {
    return _c('TreeListItem', {
      key: index,
      attrs: {
        "data": [child],
        "options": _vm.options
      }
    });
  }), 1)]);
};

var __vue_staticRenderFns__$1 = [];
/* style */

const __vue_inject_styles__$1 = function (inject) {
  if (!inject) return;
  inject("data-v-c2904702_0", {
    source: ".bold[data-v-c2904702]{color:#337ab7!important}.tree-node[data-v-c2904702]{cursor:pointer}.item[data-v-c2904702]{cursor:pointer;margin:2px}.item-hover[data-v-c2904702]{color:#337ab7;cursor:pointer;border-style:solid;border-width:thin;border-radius:4px}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__$1 = "data-v-c2904702";
/* module identifier */

const __vue_module_identifier__$1 = undefined;
/* functional template */

const __vue_is_functional_template__$1 = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__$1 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, createInjector, undefined, undefined);

var TreeListItem = __vue_component__$1;

//
var script = {
  name: "VueDirTreeView",
  components: {
    TreeListItem
  },
  props: {
    config: {
      type: Object,
      required: true
    }
  }
};

/* script */
const __vue_script__ = script;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', [_c('ul', {
    staticStyle: {
      "list-style": "none"
    }
  }, [_c('TreeListItem', {
    attrs: {
      "options": _vm.config.options,
      "data": _vm.config.data
    }
  })], 1)]);
};

var __vue_staticRenderFns__ = [];
/* style */

const __vue_inject_styles__ = function (inject) {
  if (!inject) return;
  inject("data-v-4aded942_0", {
    source: ".item[data-v-4aded942]{cursor:pointer}.bold[data-v-4aded942]{font-weight:700}ul[data-v-4aded942]{padding-left:1em;line-height:1.5em;list-style-type:dot}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__ = "data-v-4aded942";
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

var component = __vue_component__;

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = component; // Attach install function executed by Vue.use()

  installable.install = Vue => {
    Vue.component('VueDirTreeView', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export { entry_esm as default };
