'use strict';function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
var script$2 = {
  name: "FileIconPicker",
  props: {
    fileName: {
      type: String,
      required: true
    }
  },
  data: function data() {
    return {
      fileIcon: "bi bi-folder-fill",
      style: {
        color: "#fdb813"
      }
    };
  },
  created: function created() {
    this.checkIcon();
  },
  methods: {
    checkIcon: function checkIcon() {
      if ( // Word documents
      this.fileName.endsWith(".docx") || this.fileName.endsWith(".doc") || this.fileName.endsWith(".rtf") || this.fileName.endsWith(".odt")) {
        this.style = {
          color: "#1b7ced"
        };
        this.fileIcon = "bi bi-file-earmark-word-fill";
      } else if ( // Spreadsheets
      this.fileName.endsWith(".xlsx") || this.fileName.endsWith(".csv") || this.fileName.endsWith(".xls") || this.fileName.endsWith(".ods")) {
        this.style = {
          color: "#1d6f42"
        };
        this.fileIcon = "bi bi-file-earmark-spreadsheet-fill";
      } else if ( // Power point
      this.fileName.endsWith(".bmp") || this.fileName.endsWith(".ppsx") || this.fileName.endsWith(".pptx") || this.fileName.endsWith(".ppt")) {
        this.style = {
          color: "#d04423"
        };
        this.fileIcon = "bi bi-file-earmark-easel-fill";
      } else if ( // Images
      this.fileName.endsWith(".jpg") || this.fileName.endsWith(".img") || this.fileName.endsWith(".png") || this.fileName.endsWith(".svg") || this.fileName.endsWith(".gif") || this.fileName.endsWith(".tiff")) {
        this.style = {
          color: "#8C9C16"
        };
        this.fileIcon = "bi bi-file-image-fill";
      } else if ( // Programming
      this.fileName.endsWith(".vue") || this.fileName.endsWith(".ts") || this.fileName.endsWith(".html") || this.fileName.endsWith(".css") || this.fileName.endsWith(".sh") || this.fileName.endsWith(".c") || this.fileName.endsWith(".cs") || this.fileName.endsWith(".cpp")) {
        this.style = {
          color: "#15B59F"
        };
        this.fileIcon = "bi bi-file-earmark-binary-fill";
      } else if (this.fileName.endsWith(".js")) {
        // Javascript
        this.style = {
          color: "#fdb813"
        };
        this.fileIcon = "bi bi-file-earmark-code-fill";
      } else if (this.fileName.endsWith(".php")) {
        // PHP
        this.style = {
          color: "#474A8A"
        };
        this.fileIcon = "bi bi-file-earmark-code-fill";
      } else if (this.fileName.endsWith(".pdf")) {
        // Pdf
        this.style = {
          color: "#ff0000"
        };
        this.fileIcon = "bi bi-file-earmark-post";
      } else {
        this.style = {
          color: "#000"
        };
        this.fileIcon = "bi bi-file-earmark-fill";
      }
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__$2 = script$2;
/* template */

var __vue_render__$2 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('i', {
    class: _vm.fileIcon,
    style: _vm.style
  }, []);
};

var __vue_staticRenderFns__$2 = [];
/* style */

var __vue_inject_styles__$2 = undefined;
/* scoped */

var __vue_scope_id__$2 = undefined;
/* module identifier */

var __vue_module_identifier__$2 = "data-v-aaca7992";
/* functional template */

var __vue_is_functional_template__$2 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$2,
  staticRenderFns: __vue_staticRenderFns__$2
}, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

var FileIconPicker = __vue_component__$2;//
var script$1 = {
  name: "TreeListItem",
  components: {
    TreeListItem: TreeListItem,
    FileIconPicker: FileIconPicker
  },
  props: {
    options: {
      type: Object,
      required: true
    },
    data: {
      required: true
    }
  },
  data: function data() {
    return {
      isOpen: false,
      hoverTitle: false
    };
  },
  computed: {
    isLeaf: function isLeaf() {
      return this.data[0]["isLeaf"];
    }
  },
  methods: {
    toggle: function toggle() {
      if (!this.data[0]["isLeaf"]) {
        this.isOpen = !this.isOpen;
      }
    },
    trimText: function trimText(text) {
      if (text.length > 20) {
        var length = text.length;
        var trimmed = text.substr(0, 11 - 1) + "..." + text.substr(length - 7, length - 1);
        return trimmed;
      } else {
        return text;
      }
    }
  }
};function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group = css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('li', [_vm._ssrNode("<div" + _vm._ssrClass(null, _vm.hoverTitle ? 'item-hover' : 'item') + " data-v-c2904702>", "</div>", [_vm._ssrNode((!_vm.isOpen && !_vm.isLeaf ? "<i class=\"bi bi-icon-caret-right-fill\" data-v-c2904702></i>" : "<!---->") + " " + (_vm.isOpen && !_vm.isLeaf ? "<i class=\"bi bi-icon-caret-down-fill\" data-v-c2904702></i>" : "<!---->") + " " + (!_vm.isLeaf && !_vm.isOpen ? "<i class=\"bi bi-icon-folder-fill\" style=\"color: #f8d775\" data-v-c2904702></i>" : "<!---->") + " " + (!_vm.isLeaf && _vm.isOpen ? "<i class=\"bi bi-icon-folder2-open\" style=\"color: #f8d775\" data-v-c2904702></i>" : "<!---->") + " "), _vm.isLeaf ? _c('FileIconPicker', {
    attrs: {
      "fileName": _vm.data[0]['title']
    }
  }) : _vm._e(), _vm._ssrNode(" " + (!_vm.isLeaf ? "<span class=\"ml-1\" data-v-c2904702>" + _vm._ssrEscape(_vm._s(_vm.data[0]["title"])) + "</span>" : "<!---->") + " " + (_vm.isLeaf ? "<span class=\"ml-1\" data-v-c2904702>" + _vm._ssrEscape("\n      " + _vm._s(_vm.trimText(_vm.data[0]["title"])) + "\n    ") + "</span>" : "<!---->"))], 2), _vm._ssrNode(" "), _vm._ssrNode("<ul" + _vm._ssrStyle({
    "list-style": "none"
  }, null, {
    display: _vm.isOpen ? '' : 'none'
  }) + " data-v-c2904702>", "</ul>", _vm._l(_vm.data[0]['children'], function (child, index) {
    return _c('TreeListItem', {
      key: index,
      attrs: {
        "data": [child],
        "options": _vm.options
      }
    });
  }), 1)], 2);
};

var __vue_staticRenderFns__$1 = [];
/* style */

var __vue_inject_styles__$1 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-c2904702_0", {
    source: ".bold[data-v-c2904702]{color:#337ab7!important}.tree-node[data-v-c2904702]{cursor:pointer}.item[data-v-c2904702]{cursor:pointer;margin:2px}.item-hover[data-v-c2904702]{color:#337ab7;cursor:pointer;border-style:solid;border-width:thin;border-radius:4px}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__$1 = "data-v-c2904702";
/* module identifier */

var __vue_module_identifier__$1 = "data-v-c2904702";
/* functional template */

var __vue_is_functional_template__$1 = false;
/* style inject shadow dom */

var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, createInjectorSSR, undefined);

var TreeListItem = __vue_component__$1;//
var script = {
  name: "VueDirTreeView",
  components: {
    TreeListItem: TreeListItem
  },
  props: {
    config: {
      type: Object,
      required: true
    }
  }
};/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', [_vm._ssrNode("<ul style=\"list-style: none\" data-v-4aded942>", "</ul>", [_c('TreeListItem', {
    attrs: {
      "options": _vm.config.options,
      "data": _vm.config.data
    }
  })], 1)]);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-4aded942_0", {
    source: ".item[data-v-4aded942]{cursor:pointer}.bold[data-v-4aded942]{font-weight:700}ul[data-v-4aded942]{padding-left:1em;line-height:1.5em;list-style-type:dot}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__ = "data-v-4aded942";
/* module identifier */

var __vue_module_identifier__ = "data-v-4aded942";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, createInjectorSSR, undefined);

var component$1 = __vue_component__;// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var component = /*#__PURE__*/(function () {
  // Get component instance
  var installable = component$1; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('VueDirTreeView', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default':component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;